package com.yizhi.comment.application.feign;

import com.yizhi.comment.application.vo.StatisticsForumAccountVo;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

@FeignClient(name = "comment", contextId = "AdmireClient")
public interface AdmireClient {

	@GetMapping("/remote/commentAdmire/up")
	public boolean up(@ApiParam(name = "commentId",value = "评论或帖子id")@RequestParam(name = "commentId") Long commentId,@ApiParam(name = "bizType",value = "业务类型 1评论 2帖子") @RequestParam("bizType") Integer bizType);
	
	@GetMapping("/remote/commentAdmire/down")
    public boolean down(@ApiParam(name = "commentId",value = "评论或帖子id")@RequestParam(name = "commentId")Long commentId,@ApiParam(name = "bizType",value = "业务类型 1评论 2帖子") @RequestParam("bizType") Integer bizType);

	@GetMapping("/remote/commentAdmire/getNum")
	public Integer getNum(@RequestParam("bizType") Integer bizType,
						  @RequestParam(name = "taskId") Long taskId,
						  @RequestParam(name = "accountId",required = false) Long accountId);

	/**
	 * 获取用户的相关数据Map
	 * @param bizType
	 * @return
	 */
	@GetMapping("/remote/commentAdmire/getPersonalDataMap")
	public Map<Long, StatisticsForumAccountVo> getPersonalDataMap(@RequestParam("bizType") Integer bizType);
}
