package com.yizhi.comment.application.feign;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.comment.application.vo.domain.NewReplyVo;
import com.yizhi.comment.application.vo.CommentVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

@FeignClient(name = "comment", contextId = "ReplyClient")
public interface ReplyClient {

	/**
	 * 新增回复评论接口（保存）
	 * @param
	 * @return
	 */
	@PostMapping("/remote/reply/save")
	public Boolean saveReply(@RequestBody NewReplyVo reply);
	
	@GetMapping("/remote/reply/list")
	public Page<CommentVo> list(@RequestParam(name = "bizId") Long bizId, @RequestParam(name = "pageNo") Integer pageNo,
								@RequestParam(name = "pageSize") Integer pageSize);
	
	/**
	 * 用于学员移动端回复列表查询
	 */
	@GetMapping("/remote/reply/list2")
	public Page<NewReplyVo> replyList2(@RequestParam("commentId") Long commentId, @RequestParam("pageNo") Integer pageNo,
                                       @RequestParam("pageSize") Integer pageSize);
}
