package com.yizhi.comment.application.feign;

import com.yizhi.comment.application.vo.domain.SubscribeVo;
import com.yizhi.core.application.context.RequestContext;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "comment", contextId = "SubscribeClient")
public interface SubscribeClient {

	@GetMapping("/remote/subscribe/get")
	public SubscribeVo get(@RequestParam(name = "bizId") Long bizId, @RequestParam(name = "bizType") Integer bizType, @RequestParam("accountId") Long accountId, @RequestParam("siteId") Long siteId, @RequestParam("companyId") Long companyId);
	
	@GetMapping("/remote/subscribe/save")
	public SubscribeVo save(@RequestParam(name = "bizId") Long bizId, @RequestParam(name = "bizType") Integer bizType, @RequestParam("accountId") Long accountId, @RequestParam("siteId") Long siteId, @RequestParam("companyId") Long companyId);

	@GetMapping("/remote/subscribe/getMyList")
	public List<Long> getMyList(@RequestParam(name = "bizType") Integer bizType,@RequestParam("accountId") Long accountId,@RequestParam("siteId") Long siteId,@RequestParam("companyId") Long companyId);

	@GetMapping("/remote/subscribe/getAllList")
	public List<SubscribeVo> getAllList();
	
	@GetMapping("/remote/subscribe/getSubscribeNum")
	public Integer getSubscribeNum(@RequestParam(name = "bizId") Long bizId,@RequestParam(name = "bizType") Integer bizType);
	
	@PostMapping("/remote/subscribe/getMySubscribeNum")
	public Integer getMySubscribeNum(@RequestBody RequestContext context);
}
