package com.yizhi.comment.application.vo.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.yizhi.comment.application.vo.TaskAppendixVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 评论
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@Data
@ApiModel(value = "NewCommentVo", description = "评论")
@TableName("new_comment")
public class NewCommentVo {

    private static final long serialVersionUID = 1L;

	private Long id;

    @ApiModelProperty(value = "业务id")
	
	private Long bizId;

    @ApiModelProperty(value = "业务名称")
	
	private String bizName;

    @ApiModelProperty(value = "业务类型 0课程、2：论坛、 7培训项目 15专辑")
	
	private Integer bizType;
    
    @ApiModelProperty(value = "评论内容")
	private String content;

    @ApiModelProperty(value = "用于论坛--我的回复是否已读 0:未读（默认）")
    
    private Integer isRead;

    
    private Long createById;

    
    private String createByName;
    
	
	private Date createTime;
    
    
    private Long updateById;

    
    private String updateByName;

    
    private Date updateTime;
    
    @ApiModelProperty(value = "0:删除 1:上架 2:下架")
	private Integer state;

    
    private Long orgId;

    
    private Long siteId;
    
    @ApiModelProperty(value = "头像")
    private String userAvatar;

	
	private Long companyId;

    @ApiModelProperty(value = "评论附件")
    @TableField(exist = false)
    private List<TaskAppendixVo> taskAppendixVos;
}
