package com.yizhi.application.controller;


import com.yizhi.application.domain.Subscribe;
import com.yizhi.application.mapper.SubscribeMapper;
import com.yizhi.comment.application.vo.domain.SubscribeVo;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.album.application.feign.AlbumClient;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.application.service.ISubscribeService;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;

/**
 * <p>
 * 订阅 前端控制器
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@RestController
@RequestMapping("/subscribe")
public class SubscribeController {

	@Autowired
	private ISubscribeService subscribeService;
	
	@Autowired
	private SubscribeMapper subscribeMapper;
	
	@Autowired
	IdGenerator idGenerator;
	
	@Autowired
	private AlbumClient albumClient;
	
	@GetMapping("/get")
	public Subscribe get(@RequestParam(name = "bizId") Long bizId, @RequestParam(name = "bizType") Integer bizType, @RequestParam("accountId") Long accountId, @RequestParam("siteId") Long siteId, @RequestParam("companyId") Long companyId) {
		Subscribe subscribeVo = new Subscribe();
		subscribeVo.setSiteId(siteId);
		subscribeVo.setCompanyId(companyId);
		subscribeVo.setAccountId(accountId);
		subscribeVo.setBizId(bizId);
		subscribeVo.setBizType(bizType);
		EntityWrapper<Subscribe> wrapper = new EntityWrapper<Subscribe>(subscribeVo);
		Subscribe one = subscribeService.selectOne(wrapper);
		if (one==null) {
			subscribeVo.setStatus(0);
			return subscribeVo;
		}
		return one;
	}
	
	@GetMapping("/save")
	public Subscribe save(@RequestParam(name = "bizId") Long bizId, @RequestParam(name = "bizType") Integer bizType, @RequestParam("accountId") Long accountId, @RequestParam("siteId") Long siteId, @RequestParam("companyId") Long companyId) {
		Date date = new Date();
		Subscribe subscribeVo = new Subscribe();
		subscribeVo.setSiteId(siteId);
		subscribeVo.setCompanyId(companyId);
		subscribeVo.setAccountId(accountId);
		subscribeVo.setBizId(bizId);
		subscribeVo.setBizType(bizType);
		EntityWrapper<Subscribe> wrapper = new EntityWrapper<Subscribe>(subscribeVo);
		Subscribe one = subscribeService.selectOne(wrapper);
		if (one==null) {
			one = new Subscribe();
			one.setId(idGenerator.generate());
			one.setBizId(bizId);
			one.setBizType(bizType);
			one.setCompanyId(companyId);
			one.setSiteId(siteId);
			one.setAccountId(accountId);
			one.setCreateTime(date);
			one.setStatus(1);
			subscribeService.insert(one);
		}else {
			one.setUpdateById(accountId);
			one.setUpdateTime(date);
			one.setStatus(one.getStatus().equals(0)?1:0);
			subscribeService.updateById(one);
		}
		return one;
	}
	
	@GetMapping("/getMyList")
	public List<Long> getMyList(@RequestParam(name = "bizType") Integer bizType,@RequestParam("accountId") Long accountId,@RequestParam("siteId") Long siteId,@RequestParam("companyId") Long companyId){
		List<Long> list = subscribeService.getMyList(bizType, accountId, siteId, companyId);
		return list;
	}
	
	@GetMapping("getAllList")
	public List<Subscribe> getAllList(){
		List<Subscribe> list = subscribeMapper.getAllList();
		return list;
	}
	
	@GetMapping("/getSubscribeNum")
	public Integer getSubscribeNum(@RequestParam(name = "bizId") Long bizId,@RequestParam(name = "bizType") Integer bizType) {
		Subscribe subscribeVo = new Subscribe();
		subscribeVo.setBizId(bizId);
		subscribeVo.setBizType(bizType);
		subscribeVo.setStatus(1);
		return subscribeService.selectCount(new EntityWrapper<Subscribe>(subscribeVo));
	}
	
	@PostMapping("/getMySubscribeNum")
	public Integer getMySubscribeNum(@RequestBody RequestContext context) {
		Integer num = 0;
		List<Long> ids = subscribeMapper.getMyList(null, context.getAccountId(), context.getSiteId(), context.getCompanyId());
		if (!CollectionUtils.isEmpty(ids)) {
			//专辑数量
			num = albumClient.getSubcribeNum(ids);
		}
		return num;
	}
}

