package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import com.yizhi.comment.application.vo.TaskAppendixVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 评论
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
@Data

@TableName("new_comment")
public class NewComment {

    private static final long serialVersionUID = 1L;

	private Long id;

    
	@TableField("biz_id")
	private Long bizId;

    
	@TableField("biz_name")
	private String bizName;

    
	@TableField("biz_type")
	private Integer bizType;
    
    
	private String content;

    
    @TableField("is_read")
    private Integer isRead;

    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;
    
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;
    
    @TableField(value = "update_by_id", fill = FieldFill.UPDATE)
    private Long updateById;

    @TableField(value = "update_by_name", fill = FieldFill.UPDATE)
    private String updateByName;

    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;
    
    
	private Integer state;

    @TableField("org_id")
    private Long orgId;

    @TableField("site_id")
    private Long siteId;
    
    
	@TableField("user_avatar")
    private String userAvatar;

	@TableField("company_id")
	private Long companyId;

    
    @TableField(exist = false)
    private List<TaskAppendixVo> taskAppendixVos;
}
