package com.yizhi.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.application.domain.NewComment;
import com.yizhi.comment.application.vo.domain.NewCommentVo;
import com.yizhi.comment.application.vo.CommentVo;
import com.yizhi.comment.application.vo.ManageCommentVo;
import com.yizhi.comment.application.vo.NewApiCommentVo;
import com.yizhi.comment.application.vo.PostsCommentVo;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;

import java.util.List;

/**
 * <p>
 * 评论 Mapper 接口
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
public interface CommentMapper extends BaseMapper<NewComment> {

    List<CommentVo> getCommentPage(@Param("bizId") Long bizId, @Param("bizType") Integer bizType, RowBounds rowBounds);

    Integer getCommentPageCount(@Param("bizId") Long bizId, @Param("bizType") Integer bizType);

    List<CommentVo> getCommentList(@Param("bizId") Long bizId, @Param("bizType") Integer bizType);

    List<NewApiCommentVo> apiCommentPage(@Param("bizId") Long bizId, @Param("bizType") Integer bizType, @Param("accountId") Long accountId, RowBounds rowBounds);

    Integer apiCommentPageCount(@Param("bizId") Long courseId, @Param("bizType") Integer bizType, @Param("accountId") Long accountId);

    List<com.yizhi.application.domain.NewComment> getallComments();

    /**
     * 帖子 我收到的回复
     *
     * @param type      业务类型
     * @param keyWord   业务关键词
     * @param postsIds  帖子ids
     * @param accountId
     * @param rowBounds
     * @return
     */

    List<PostsCommentVo> myReceivedPage(@Param("type") Integer type,
                                        @Param("keyWord") String keyWord,
                                        @Param("postsIds") List<Long> postsIds,
                                        @Param("keyWordPostsIds") List<Long> keyWordPostsIds,
                                        @Param("accountId") Long accountId,
                                        RowBounds rowBounds);

    Integer myReceivedPageNum(@Param("type") Integer type,
                              @Param("keyWord") String keyWord,
                              @Param("postsIds") List<Long> postsIds,
                              @Param("keyWordPostsIds") List<Long> keyWordPostsIds,
                              @Param("accountId") Long accountId);

    /**
     * 帖子 我发出的回复
     *
     * @param type            业务类型
     * @param keyWord         业务关键词
     * @param keyWordPostsIds 帖子ids
     * @param accountId
     * @param rowBounds
     * @return
     */

    List<PostsCommentVo> mySendPage(@Param("type") Integer type,
                                    @Param("keyWord") String keyWord,
                                    @Param("keyWordPostsIds") List<Long> keyWordPostsIds,
                                    @Param("accountId") Long accountId,
                                    RowBounds rowBounds);

    Integer mySendPageNum(@Param("type") Integer type,
                          @Param("keyWord") String keyWord,
                          @Param("keyWordPostsIds") List<Long> keyWordPostsIds,
                          @Param("accountId") Long accountId);

    /**
     * 我的管理--回复管理
     *
     * @param type
     * @param postsId
     * @param rowBounds
     * @return
     */
    List <PostsCommentVo> getPageByPostsId(@Param("type") Integer type, @Param("postsId") Long postsId, RowBounds rowBounds);
    Integer getPageByPostsIdNum(@Param("type") Integer type, @Param("postsId") Long postsId);


    /**
     * 论坛管理端-单个帖子的回复列表
     *
     * @param type
     * @param postsId
     * @param rowBounds
     * @return
     */
    List<ManageCommentVo> getPageToManage(@Param("type") Integer type, @Param("postsId") Long postsId, RowBounds rowBounds);

    Integer getPageToManageNum(@Param("type") Integer type, @Param("postsId") Long postsId);
}
