package com.yizhi.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.domain.NewComment;
import com.yizhi.comment.application.vo.*;
import com.yizhi.comment.application.vo.domain.NewCommentVo;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 评论 服务类
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
public interface ICommentService extends IService<NewComment> {

    Page<com.yizhi.comment.application.vo.CommentVo> getCommentPage(Long bizId, Integer bizType, int pageNo, int pageSize);
    
    List<CommentVo> getCommentList(Long bizId, Integer bizType);
    
    Page<NewApiCommentVo> apiCommentPage(Long bizId, Integer bizType, Long accountId, int pageNo, int pageSize);

    Page<NewApiCommentVo> getPage(CommentParam param);

    /**
     * 论坛 收到的回复
     * @param param
     * @return
     */
    Page<PostsCommentVo> myReceivedPage(CommentParam param);

    /**
     * 获取评论id，评论的map
     * @param ids
     * @return
     */
    Map<Long, NewCommentVo> getMap(List<Long> ids);

    /**
     * 论坛 发送的回复
     * @param param
     * @return
     */
    Page<PostsCommentVo> mySendPage(CommentParam param);

    Page<PostsCommentVo> getPageByPostsId(Integer type, Long postsId, Integer pageNo, Integer pageSize);

    /**
     * 论坛-评论删除或下架
     * @param operationType 1-下架   2-删除
     * @param id
     * @return
     */
    Integer down(Integer operationType,Long id);

    Page<ManageCommentVo> getPageToManage(Integer type, Long postsId, Integer pageNo, Integer pageSize);

    public void updatePostsInfo(Long bizId, Integer bizType, Long siteId,Date date, Boolean save,Boolean isManage);

    Map<Long, StatisticsForumAccountVo> getPersonalDataMap(Integer bizType);

    Integer save(NewCommentVo comment);

    /**
     * 更新评论回复的已读状态  论坛需要
     * @param taskType
     * @param taskId
     * @return
     */
    Integer updateIsReadField(Integer taskType,List<Long> taskId);

    Integer myNum(Integer taskType, List<Long> taskIds);

    NewApiCommentVo getCommentDetails(Integer taskType, Long taskId, Long commentId, Long author, Integer orderType, Integer pageNo, Integer pageSize);
}
