package com.yizhi.application.service;

import com.yizhi.application.domain.NewReply;
import com.yizhi.comment.application.vo.domain.NewReplyVo;
import com.yizhi.comment.application.vo.CommentParam;
import com.yizhi.comment.application.vo.CommentVo;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.comment.application.vo.PostsCommentVo;
import com.yizhi.comment.application.vo.StatisticsForumAccountVo;

/**
 * <p>
 * 回复 服务类
 * </p>
 *
 * @author yizhi123
 * @since 2019-12-30
 */
public interface IReplyService extends IService<NewReply> {

    Page<CommentVo> getCommentPage(Long commentId, int pageNo, int pageSize);
    
    List<NewReply> list(Long bizId);

    /**
     * 获取《评论id,回复数》
     * @param commentId
     * @return
     */
    public Map<Long,Integer> getCountsByCommentId(List<Long> commentId);

    /**
     * 分页获取回复
     * @param commentId

     * @return
     */

    Page<NewReplyVo> getPage(Long commentId, CommentParam param);

    /**
     * 获取《评论id,回复》目前是传楼主id
     *
     * @return
     */
    public Map<Long, List<NewReplyVo>> getMapByAccountId(Integer taskType, Long taskId, Long author);

    /**
     * 获取回复id，回复的map
     * @param ids
     * @return
     */
    Map<Long, NewReplyVo> getMap(List<Long> ids);

    List<PostsCommentVo> catCommunication(Long id);

    /**
     * 论坛-评论删除或下架
     * @param operationType 1-下架   2-删除
     * @param id
     * @return
     */
    Integer down(Integer operationType,Long id);

    /**
     * 获取《用户id，回复数》
     * @param bizType
     * @param map
     * @return
     */
    Map<Long, StatisticsForumAccountVo> getPersonalDataMap(Integer bizType, Map<Long, StatisticsForumAccountVo> map);

}
